<?php
function miniorange_saml_idp_licensing() {

  global $base_url;

  drupal_add_css( drupal_get_path('module', 'miniorange_saml_idp'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
  drupal_add_css( drupal_get_path('module', 'miniorange_saml_idp'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
  drupal_add_js( drupal_get_path('module', 'miniorange_saml_idp'). '/js/testidpconfig.js' , array('group' => JS_DEFAULT, 'every_page' => FALSE));
  drupal_add_js( drupal_get_path('module', 'miniorange_saml_idp'). '/js/dru_visual_tour.js' , array('group' => JS_DEFAULT, 'every_page' => FALSE));

  $form['markup_0'] = array(
    '#markup' =>'<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout" style="margin-right:0px;padding-left: 28px;padding-right: 33px;padding-top: 5px"><br><h3>&emsp;'.t('UPGRADE PLANS').'  </h3><hr>'
  );

  $heading = array(
    'features'   => '<h2 style="color: white">FEATURES</h2>',
    'free'       => '<br><h2 style="color: white">FREE</h2> <p class="mo_pricing-rate"><sup>$</sup> 0</p>',
    'premium'    => '<br><h2 style="color: white">PREMIUM</h2><p class="mo_pricing-rate" id="premium_price"><sup>$</sup> 450/year <sup>*</sup></p><br><label for="instances_premium" style="color: white">Users: </label>'. getPricingList(),
  );

  $buttons = array(
    'features'   => '',
    'free'       => '<span class="mo_saml_btn mo_saml_btn-custom mo_saml_btn-danger mo_saml_btn-sm" style="background-color: #337ab7 !important; border-color: #337ab7 !important;">Current Plan</a>',
    'premium'    => '<a class="mo_saml_btn mo_saml_btn-custom mo_saml_btn-danger mo_saml_btn-sm" href="'.MiniorangeSAMLIdpConstants::PORTAL_URL.'" target="_blank" style="background-color: #337ab7 !important; border-color: #337ab7 !important;">Upgrade Now</a>',
  );

  $rows = array(
    [$heading['features'], $heading['free'], $heading['premium']],
    [$buttons['features'], $buttons['free'], $buttons['premium']],

    [t('Unlimited Authentication via SP'),              '&#x2714;', '&#x2714;'],
    [t('Allows SSO for admin user'),                    '&#x2714;', '&#x2714;'],
    [t('Configure IdP Using Metadata URL'),             '&#x2714;', '&#x2714;'],
    [t('Configure IdP Using Metadata File'),            '&#x2714;', '&#x2714;'],
    [t('Export Configuration'),                         '&#x2714;', '&#x2714;'],
    [t('Sign SAML Assertion'),                          '&#x2714;', '&#x2714;'],
    [t('Sign SAML Response'),                           '',         '&#x2714;'],
    [t('Encrypted SAML Assertion'),                     '',         '&#x2714;'],
    [t('Allows SSO for all user roles'),                '',         '&#x2714;'],
    [t('Multiple SP support**'),                          '',         '&#x2714;'],
    [t('Export Configuration'),                         '',         '&#x2714;'],
    [t('Send Constant User Attributes from Drupal'),    '',         '&#x2714;'],
    [t('Send Additional User information from Drupal'), '',         '&#x2714;'],
    [t('Dynamic RelayState'),                           '',         '&#x2714;'],
    [t('IdP Initiated Login'),                          '',         '&#x2714;'],
    [t('SAML Single Logout'),                           '',         '&#x2714;'],
    [t('Debug logs'),                                   '',         '&#x2714;'],
    [t('Custom X.509 Certificate'),                     '',         '&#x2714;'],
    [t('Profile module support'),                       '',         '&#x2714;'],
    [t('HTTP-POST Binding for SAML Logout'),            '',         '&#x2714;'],
  );

  $form['miniorange_saml_licensing_table'] = [
    '#theme' => 'table',
    '#rows' => $rows,
    '#attributes' => ['class' => 'mo_upgrade_plans_features'],
  ];

  $form['markup_how to upgrade'] = array(
    '#markup' => '<h3 class="mo_saml_text_center"><br>How to Upgrade to Licensed Version Module</h3><br>'
  );

  $rows = [
    [ t('<b>1.</b> Click on Upgrade Now button for required licensed plan, and you will be redirected to miniOrange login console.</li>'), t('<b>5.</b> Uninstall and then delete the free version of the module from your Drupal site.') ],
    [ t('<b>2.</b> Enter your username and password with which you have created an account with us. After that you will be redirected to payment page.'), t('<b>6.</b> Now install the downloaded licensed version of the module.') ],
    [ t('<b>3.</b> Enter your card details and proceed for payment. On successful payment completion, the Licensed version module(s) will be available to download.'), t('<b>7.</b> Clear Drupal Cache from <a href="'.$base_url.'/admin/config/development/performance" target="_blank" >here</a>.') ],
    [ t('<b>4.</b> Download the licensed module(s) from a module Releases and Downloads section.'), t('<b>8.</b> After enabling the licensed version of the module, login using the account you have registered with us.') ],
  ];

  $form['miniorange_how_to_upgrade_table'] = array(
    '#theme' => 'table',
    '#rows' => $rows,
    '#attributes' => ['class' => 'mo_how_to_upgrade'],
  );

  $form['markup_faq'] = array(
    '#markup' => '<h3 class="mo_saml_text_center"><br>Frequently Asked Questions</h3>'
  );

  $faq = array(
    'Are the Licenses Perpetual?' => 'The miniOrange IDP module is annual subscription based module.',
    'Does miniOrange Offer Technical Support?' => 'Yes, we provide 24x7 support for all and any issues you might face while using the module, which includes technical support from our developers. You can get prioritized support based on the Support Plan you have opted.',
    'What is the Refund Policy?' => 'At miniOrange, we want to ensure you are 100% happy with your purchase. If the module that you purchased is not working as advertised and you\'ve attempted to resolve any issues with our support team, which couldn\'t get resolved, we will refund the whole amount given that you raised a refund request within the first 10 days of the purchase. Please email us at <a href="mailto:drupalsupport@xecurify.com">drupalsupport@xecurify.com</a> for any queries regarding the return policy or contact us <a href="https://www.miniorange.com/contact" target="_blank">here</a>.',
    'Does miniOrange store any User data ?' => 'miniOrange does not store or transfer any data from the Identity Provider (IdP). All the data remains within your premises/server.',
  );

  $questions = [];

  foreach ($faq as $title => $description) {
    $questions[] = [
      '#type' => 'fieldset',
      '#title' => t($title),
      '#collapsible' => TRUE,
      '#collapsed' => TRUE,
      '#attributes' => array('style' => 'width: 50em;'),
      ['details_markup' => [
        '#markup' => t($description),
      ]],
    ];
  }

  $form['miniorange_FAQ_table'] = array(
    '#theme' => 'table',
    '#attributes' => ['class' => 'mo_faq_table'],
    0 => array(
      'question_one' => &$questions[0],
      'question_two' => &$questions[1],
    ),
    1 => array(
      'question_three' => &$questions[2],
      'question_four' => &$questions[3],
    ),
    '#rows' => array(
      0 => array(
        array('data' => &$questions[0]),
        array('data' => &$questions[1]),
      ),

      1 =>  array(
        array('data' => &$questions[2]),
        array('data' => &$questions[3]),
      ),
    )
  );

  $form['miniorange_saml_instance_based'] = array(
    '#markup' => t('<br><div><b>*</b> This module follows an <b>Instance Based</b> licensing structure. The listed prices are for purchase of a single instance. If you are planning to use the module on multiple instances, you can check out the bulk purchase discount on our <a href="'.MiniorangeSAMLIdpConstants::PORTAL_URL.'" target="_blank">website</a>.</div><br>
                        <div> <b>**</b> If you have multiple SPs, there is additional cost for every supplementary SP.</div><br>
                        <div class="mo_saml_highlight_background_note" style="width: 98%"><b><u>What is an Instance:</u></b> A Drupal instance refers to a single installation of a Drupal site. It refers to each individual website where the module is active. In the case of multisite/subsite Drupal setup, each site with a separate database will be counted as a single instance. For e.g. If you have the dev-staging-prod type of environment then you will require 3 licenses of the module (with additional discounts applicable on pre-production environments).</div><br>
                        '),
  );

  Utilities::AddrfdButton($form,$form_state);

  $form['markup_8'] = array(
    '#markup' => '</div></div>'
  );

  return $form;

}

function getPricingList() {
  $priceData = array(
    '100' => t('1-100'),
    '200' => t('101-200'),
    '300' => t('201-300'),
    '400' => t('301-400'),
    '500' => t('401-500'),
    '1000' => t('501-1000'),
    '2000' => t('1001-2000'),
    '3000' => t('2001-3000'),
    '4000' => t('3001-4000'),
    '5000' => t('4001-5000'),
    '6000' => t('5000+ Users'),
  );

  $option = '<select id="instances_premium" name="instances" onchange="Instance_Pricing(this.value)">';

  foreach ($priceData as $id => $price) {
    $option .= '<option value="'.$id.'">'.$price.'</option>';
  }

  $option .='</select>';

  return $option;
}

function send_rfd_query(&$form, $form_state) {
  $email = trim($form['customer_email']['#value']);
  $demo_plan = 'Drupal 7 IdP Premium Module';
  $description_doubt = trim($form['description_doubt']['#value']);
  $query = $demo_plan.' ->'.$description_doubt;

  if(valid_email_address($email))
    Utilities::send_demo_query($email, $query, $description_doubt);
  else {
    drupal_set_message('Please enter valid Email ID', 'error');
    return;
  }
}
